DL_DecryptorImpl< SCHEME_OPTIONS > Class Template Reference

_ More...

`#include <pubkey.h>`

Inheritance diagram for DL_DecryptorImpl< SCHEME_OPTIONS >:

## Public Types

typedef SCHEME_OPTIONS::PrivateKey::Element | Element
typedef SCHEME_OPTIONS | SchemeOptions

## Public Member Functions

PrivateKey & | AccessPrivateKey ()
PublicKey & | AccessPublicKey ()
const SCHEME_OPTIONS::PrivateKey & | GetKey () const
SCHEME_OPTIONS::PrivateKey & | AccessKey ()
std::string | AlgorithmName () const
DecodingResult | Decrypt (RandomNumberGenerator &rng, const byte *ciphertext, size_t ciphertextLength, byte *plaintext, const NameValuePairs &parameters=g_nullNameValuePairs) const
| decrypt a byte string, and return the length of plaintext More...
size_t | MaxPlaintextLength (size_t ciphertextLength) const
size_t | CiphertextLength (size_t plaintextLength) const
bool | ParameterSupported (const char *name) const
virtual BufferedTransformation * | CreateDecryptionFilter (RandomNumberGenerator &rng, BufferedTransformation *attachment=NULL, const NameValuePairs &parameters=g_nullNameValuePairs) const
| create a new decryption filter More...
DecodingResult | FixedLengthDecrypt (RandomNumberGenerator &rng, const byte *ciphertext, byte *plaintext, const NameValuePairs &parameters=g_nullNameValuePairs) const
| decrypt a fixed size ciphertext
virtual size_t | FixedCiphertextLength () const
| return fixed ciphertext length, if one exists, otherwise return 0 More...
virtual size_t | FixedMaxPlaintextLength () const
| return maximum plaintext length given the fixed ciphertext length, if one exists, otherwise return 0
CryptoMaterial & | AccessMaterial ()
| returns a reference to the crypto material used by this object
const CryptoMaterial & | GetMaterial () const
| returns a const reference to the crypto material used by this object
virtual const PrivateKey & | GetPrivateKey () const
void | BERDecode (BufferedTransformation &bt)
| for backwards compatibility, calls AccessMaterial().Load(bt)
void | DEREncode (BufferedTransformation &bt) const
| for backwards compatibility, calls GetMaterial().Save(bt)
virtual Clonable * | Clone () const
| this is not implemented by most classes yet

## Static Public Member Functions

static std::string | StaticAlgorithmName ()

## Protected Types

typedef DL_PrivateKey< SCHEME_OPTIONS::Element > | KeyInterface

## Protected Member Functions

const DL_ElgamalLikeSignatureAlgorithm< Element > & | GetSignatureAlgorithm () const
const DL_KeyAgreementAlgorithm< Element > & | GetKeyAgreementAlgorithm () const
const DL_KeyDerivationAlgorithm< Element > & | GetKeyDerivationAlgorithm () const
const DL_SymmetricEncryptionAlgorithm & | GetSymmetricEncryptionAlgorithm () const
HashIdentifier | GetHashIdentifier () const
const PK_SignatureMessageEncodingMethod & | GetMessageEncodingInterface () const
DL_DecryptorBase< SCHEME_OPTIONS::Element >::KeyInterface & | AccessKeyInterface ()
const DL_DecryptorBase< SCHEME_OPTIONS::Element >::KeyInterface & | GetKeyInterface () const
size_t | GetDigestSize () const
const DL_GroupParameters< Element > & | GetAbstractGroupParameters () const
DL_GroupParameters< Element > & | AccessAbstractGroupParameters ()

## Detailed Description

### template<class SCHEME_OPTIONS>
class DL_DecryptorImpl< SCHEME_OPTIONS >

_

Definition at line 1368 of file pubkey.h.

## Member Function Documentation

DecodingResult DL_DecryptorBase< SCHEME_OPTIONS::Element >::Decrypt | ( | RandomNumberGenerator & | rng,
|  | const byte * | ciphertext,
|  | size_t | ciphertextLength,
|  | byte * | plaintext,
|  | const NameValuePairs & | parameters = `g_nullNameValuePairs`
| ) |  | const

inline virtual inherited

decrypt a byte string, and return the length of plaintext

Precondition
  size of plaintext == MaxPlaintextLength(ciphertextLength) bytes.

Returns
  the actual length of the plaintext, indication that decryption failed.

Implements PK_Decryptor.

Definition at line 1184 of file pubkey.h.

virtual BufferedTransformation* PK_Decryptor::CreateDecryptionFilter | ( | RandomNumberGenerator & | rng,
|  | BufferedTransformation * | attachment = `NULL`,
|  | const NameValuePairs & | parameters = `g_nullNameValuePairs`
| ) |  | const

virtual inherited

create a new decryption filter

Note
  caller is responsible for deleting the returned pointer

virtual size_t PK_CryptoSystem::FixedCiphertextLength | ( |  | ) | const

inline virtual inherited

return fixed ciphertext length, if one exists, otherwise return 0

Note
  "Fixed" here means length of ciphertext does not depend on length of plaintext. It usually does depend on the key length.

Definition at line 1211 of file cryptlib.h.

The documentation for this class was generated from the following file:

- pubkey.h